#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#define DBGI(a) printf(#a " ==> %d\n", a)
#define DBGF(a) printf(#a " ==> %f\n", a)

#define DIM 10

void foo (char *fmt, ...);

int main (int argc, char ** argv) {

  double b, b1;
  int a, a1, val;

  char s[DIM];

  a = 1;
  a1 = 2;
  b = 3.0;
  b1 = 4.0;

  strncpy (s, "df", DIM);
  fprintf (stdout, "\n formato %s\n", s);
  foo (s, a, b);

  strncpy (s, "dffd", DIM);
  fprintf (stdout, "\n formato %s\n", s);
  foo (s, a, b, b1, a1);

  return 0;
}

void foo (char *fmt, ...) {
  
  int d;
  double c;

  va_list ap;
  
  va_start(ap, fmt);
  
  while (*fmt) {  /* una stringa e' terminata da \0 */
    switch(*(fmt++)) {
      case 'd':
        d = va_arg(ap, int);
        printf("int %d\n", d);
        break;
      case 'f':
        c = va_arg(ap, double);
        printf("float %f\n", c);
        break;
    }
  }
  va_end(ap);

  return;
}
